"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
exports.__esModule = true;
exports.authStoreBuilder = void 0;
var react_1 = require("react");
var defaultAuthStoreArg = {
    getToke: function () { return null; },
    setToken: function (token) { },
    removeToken: function () { }
};
var authStoreBuilder = function (authBuilderArg) {
    if (authBuilderArg === void 0) { authBuilderArg = defaultAuthStoreArg; }
    var getToke = authBuilderArg.getToke, setToken = authBuilderArg.setToken, removeToken = authBuilderArg.removeToken;
    var AuthContext = (0, react_1.createContext)({
        isLogin: false,
        user: null,
        login: function (user) {
        },
        logout: function () {
        }
    });
    var token = getToke();
    var AuthProvider = function (props) {
        var _a = (0, react_1.useState)({
            isLogin: !!token,
            user: null
        }), auth = _a[0], setAuth = _a[1];
        function login(user) {
            setToken(user.token);
            setAuth({ isLogin: true, user: user });
        }
        function logout() {
            removeToken();
            setAuth({ isLogin: false, user: null });
        }
        return (<AuthContext.Provider value={__assign(__assign({}, auth), { login: login, logout: logout })}>
        {props.children}
      </AuthContext.Provider>);
    };
    function useAuthStore() {
        return (0, react_1.useContext)(AuthContext);
    }
    return {
        AuthProvider: AuthProvider,
        useAuthStore: useAuthStore
    };
};
exports.authStoreBuilder = authStoreBuilder;
