"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
exports.__esModule = true;
exports.httpProviderBuilder = void 0;
var react_1 = require("react");
var APPLICATION_JSON = 'application/json';
var CONTENT_TYPE = 'Content-Type';
// Default values
var defaultCreateHttp = {
    baseUrl: '',
    defaultApplyError: function (error) { },
    getToken: function () { return null; },
    refreshToken: function (res) { },
    logoutAction: function () { }
};
var defaultRequestConfig = {
    url: '',
    method: 'get',
    header: new Map(),
    auth: false,
    state: 'one',
    preventRefreshToken: false,
    applyData: function (response) { throw 'you have to provide applyData property ...'; },
    dependinces: []
};
var defaultRequestParams = {
    query: {},
    pathParams: [],
    body: null
};
var httpProviderBuilder = function (createHttpParams) {
    var _this = this;
    if (createHttpParams === void 0) { createHttpParams = defaultCreateHttp; }
    createHttpParams = __assign(__assign({}, defaultCreateHttp), createHttpParams);
    var baseUrl = createHttpParams.baseUrl, defaultApplyError = createHttpParams.defaultApplyError, getToken = createHttpParams.getToken, refreshToken = createHttpParams.refreshToken, logout = createHttpParams.logoutAction;
    return function (reqConfig) {
        if (reqConfig === void 0) { reqConfig = defaultRequestConfig; }
        if (!reqConfig.applyError)
            reqConfig.applyError = defaultApplyError;
        reqConfig = __assign(__assign({}, defaultRequestConfig), reqConfig);
        var _a = (0, react_1.useState)(false), isLoading = _a[0], setIsLoading = _a[1];
        var _b = (0, react_1.useState)(null), error = _b[0], setError = _b[1];
        var sendRequest = (0, react_1.useCallback)(function (params) {
            if (params === void 0) { params = defaultRequestParams; }
            return __awaiter(_this, void 0, void 0, function () {
                var variablesInUrl, queryParams, reqHeader, jwt, bodyBuilder, response, data, err_1, err2_1, httpResponse, error_1;
                var _a;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            params = __assign(__assign({}, defaultRequestParams), params);
                            if (isLoading && reqConfig.state === 'one')
                                return [2 /*return*/];
                            setIsLoading(true);
                            setError(null);
                            variablesInUrl = ((params === null || params === void 0 ? void 0 : params.pathParams) && ((_a = params.pathParams) === null || _a === void 0 ? void 0 : _a.length) > 0) ? '/' + params.pathParams.join('/') : '';
                            queryParams = '';
                            if ((params === null || params === void 0 ? void 0 : params.query) && Object.entries(params.query).length > 0) {
                                queryParams = '?';
                                Object.entries(params.query).forEach(function (item) {
                                    queryParams += "".concat(item[0], "=").concat(item[1], "&");
                                });
                                queryParams.slice(-1);
                            }
                            reqHeader = new Headers();
                            ((params === null || params === void 0 ? void 0 : params.body) && !(params.body instanceof FormData)) && reqHeader.append(CONTENT_TYPE, APPLICATION_JSON);
                            if (reqConfig.header) {
                                reqConfig.header.forEach(function (value, key) {
                                    reqHeader.append(key, value);
                                });
                            }
                            if (reqConfig.auth) {
                                jwt = getToken();
                                if (!jwt)
                                    logout();
                                reqHeader.append('Authorization', "Bearer ".concat(jwt));
                            }
                            if (params.body) {
                                if (reqHeader.get(CONTENT_TYPE) === APPLICATION_JSON) {
                                    bodyBuilder = JSON.stringify(params.body);
                                }
                                else if (params.body instanceof FormData) {
                                    bodyBuilder = params.body;
                                }
                            }
                            _b.label = 1;
                        case 1:
                            _b.trys.push([1, 13, 14, 15]);
                            return [4 /*yield*/, fetch(baseUrl + reqConfig.url + variablesInUrl + queryParams, {
                                    method: reqConfig.method.toUpperCase(),
                                    headers: reqHeader,
                                    body: bodyBuilder
                                })];
                        case 2:
                            response = _b.sent();
                            if (response.status === 401) {
                                logout();
                            }
                            if (!(response.status >= 400)) return [3 /*break*/, 4];
                            return [4 /*yield*/, response.json()];
                        case 3: throw _b.sent();
                        case 4:
                            if (reqConfig.auth && !reqConfig.preventRefreshToken) {
                                refreshToken(response);
                            }
                            data = void 0;
                            _b.label = 5;
                        case 5:
                            _b.trys.push([5, 7, , 12]);
                            return [4 /*yield*/, response.json()];
                        case 6:
                            data = (_b.sent());
                            return [3 /*break*/, 12];
                        case 7:
                            err_1 = _b.sent();
                            _b.label = 8;
                        case 8:
                            _b.trys.push([8, 10, , 11]);
                            return [4 /*yield*/, response.text()];
                        case 9:
                            data = (_b.sent());
                            return [3 /*break*/, 11];
                        case 10:
                            err2_1 = _b.sent();
                            data = undefined;
                            return [3 /*break*/, 11];
                        case 11: return [3 /*break*/, 12];
                        case 12:
                            httpResponse = {
                                data: data,
                                headers: response.headers,
                                status: response.status,
                                statusText: response.statusText
                            };
                            reqConfig.applyData(httpResponse);
                            return [3 /*break*/, 15];
                        case 13:
                            error_1 = _b.sent();
                            setError(error_1);
                            return [3 /*break*/, 15];
                        case 14:
                            setIsLoading(false);
                            return [7 /*endfinally*/];
                        case 15: return [2 /*return*/];
                    }
                });
            });
        }, __spreadArray([isLoading], reqConfig.dependinces, true));
        (0, react_1.useEffect)(function () {
            if (error)
                reqConfig.applyError(error);
        }, [error]);
        return {
            sendRequest: sendRequest,
            error: error,
            isLoading: isLoading
        };
    };
};
exports.httpProviderBuilder = httpProviderBuilder;
